/*
 * livepatch_bsc1193863
 *
 * Fix for CVE-2018-25020, bsc#1193863
 *
 *  Upstream commit:
 *  050fad7c4534 ("bpf: fix truncated jump targets on heavy expansions")
 *
 *  SLE12-SP3 commit:
 *  64cd10a7e116fd15bf2b0ccf6dff865597be9ae9
 *
 *  SLE12-SP4 and SLE15 commit:
 *  bf191610f043b8a4762b7629856f44fa34d12233
 *
 *  SLE12-SP5 and SLE15-SP1:
 *  14810e5b466cd1a3e9936e04b766e7e5fecc74aa
 *
 *  SLE15-SP2 and -SP3 commit:
 *  not affected
 *
 *
 *  Copyright (c) 2022 SUSE
 *  Author: Nicolai Stange <nstange@suse.de>
 *
 *  Based on the original Linux kernel code. Other copyrights apply.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include <linux/kernel.h>
#include <linux/module.h>
#include "livepatch_bsc1193863.h"
#include "bsc1193863_common.h"

int livepatch_bsc1193863_init(void)
{
	int ret;

	ret = livepatch_bsc1193863_bpf_core_init();
	if (ret)
		return ret;

	ret = livepatch_bsc1193863_net_filter_init();
	if (ret) {
		livepatch_bsc1193863_bpf_core_cleanup();
		return ret;
	}

	return 0;
}

void livepatch_bsc1193863_cleanup(void)
{
	livepatch_bsc1193863_net_filter_cleanup();
	livepatch_bsc1193863_bpf_core_cleanup();
}
